#ifndef __PFILESEL_H
#define __PFILESEL_H

#include <stdio.h> /* FILE * */

struct moduleinfostruct;
extern char fsGetNextFile(char *path, struct moduleinfostruct *info, FILE **); /* info comes from external buffer */
extern char fsFilesLeft(void);
extern signed char fsFileSelect(void);
/* extern char fsAddFiles(const char *);      use the playlist instead..*/
extern char fsInit(void);
extern void fsClose(void);

extern char fsListScramble;
extern char fsListRemove;
extern char fsLoopMods;
extern char fsScanNames;
extern char fsScanArcs;
extern char fsScanInArc;
extern char fsScanMIF;
extern char fsScrType;
extern char fsEditWin;
extern char fsColorTypes;
extern char fsInfoMode;
extern char fsPutArcs;
extern char fsWriteModInfo;
extern const char *(fsTypeNames[256]); /* type description */

extern int fsIsModule(const char *ext);

struct preprocregstruct
{
	void (*Preprocess)(const char *path, struct moduleinfostruct *info, FILE **f);
	struct preprocregstruct *next;
};

struct filehandlerstruct
{
	int (*Process)(const char *path, struct moduleinfostruct *m, FILE **f);
};

struct interfacestruct
{
	int (*Init)(const char *path, struct moduleinfostruct *info, FILE **f);
	int (*Run)(void);
	void (*Close)(void);
};

#define RD_PUTSUBS 1
#define RD_ARCSCAN 2
#define RD_DIRRECURSE 4
#define RD_PUTDSUBS 16

#if 0
struct modlist;

extern char *dmGetPath(char *path, unsigned short ref);
extern unsigned short dmGetPathReference(const char *p);
extern unsigned short dmGetDriveDir(int drv);
#endif

#if 0
extern char mifMemRead(const char *name, unsigned short size, char *ptr);

struct fsgetfileregstruct
{
	void (*GetFile)(char *path, FILE **f);
	struct fsgetfileregstruct *next;
};

#endif

extern void RegisterDrive(const char *dmDrive);

void fsConvFileName12(char *c, const char *f, const char *e);
void convfilename12wc(char *c, const char *f, const char *e);
int fsMatchFileName12(const char *a, const char *b);

#endif
