/* OpenCP Module Player
 * copyright (c) '94-'04 Niklas Beisert <nbeisert@physik.tu-muenchen.de>
 *
 * ITPlay file type detection routines for the file selector
 *
 * revision history: (please note changes here)
 *  -nb980510   Niklas Beisert <nbeisert@physik.tu-muenchen.de>
 *    -first release
 */

#include "config.h"
#include <string.h>
#include "types.h"
#include "filesel/mdb.h"


static unsigned char itpGetModuleType(const char *buf)
{
	if (*(unsigned long*)buf==0x4D504D49)
		return mtIT;
	return 0xFF;
}


static int itpReadMemInfo(struct moduleinfostruct *m, const char *buf, size_t len)
{
	int type;
	int i;
	
	if (!memcmp(buf, "ziRCONia", 8))
	{
		strcpy(m->modname, "MMCMPed module");
		return 0;
	}

	type=itpGetModuleType(buf);
	m->modtype=type;
	switch (type)
	{
		case mtIT:
			if (buf[0x2C]&4)
				if (buf[0x2B]<2)
					return 0;
			memcpy(m->modname, buf+4, 26);
			m->modname[26]=0;
			m->channels=0;
			for (i=0; i<64; i++)
				if (!(buf[64+i]&0x80))
					m->channels++;
			memset(&m->composer, 0, sizeof(m->composer));
			return 1;
	}
	return 0;
}

static int itpReadInfo(struct moduleinfostruct *m, FILE *fp, const char *bf, size_t len)
{
	return 0;
}

struct mdbreadnforegstruct itpReadInfoReg = {itpReadMemInfo, itpReadInfo};
